/*
    Introduction to OOP with Java (5th Ed), McGraw-Hill

    Wu/Otani

    Chapter 11 Sample Program: Test linear search.

    File: Ch11TestLinearSearch.java
*/

class Ch11TestLinearSearch {

    private final static int EMPTY = -1;

    public static void main (String[] args) {

        int[ ] number = new int[1000];

        SearchRoutines mySearch = new SearchRoutines( );

        int    position;


        //Initialize the array elements to empty
        for (int i = 0; i < number.length; i++ ) {
            number[i] = EMPTY;

        }

        //Store numbers from 0 to 999
        //into an array of int at a random position
        int num = 0, loc;

        while (num < number.length) {

            //Generate a random number between 0 and number.length-1
            //and use this value as the index of the position to
            //store the number

            loc   = (int) Math.floor( Math.random() * number.length );

            while (number[loc] != EMPTY) {
                //loc already has a number in it
                //generate another location

                loc = (int) Math.floor( Math.random() * number.length );
            }

            number[loc] = num;

            num++;
        }


        //Test linear search
        position = mySearch.linearSearch(number, 435);

        System.out.println( "Search 435; Index returned:   " + position );

        position = mySearch.linearSearch(number, 23);

        System.out.println( "Search 23; Index returned:   " + position );

        position = mySearch.linearSearch(number, 98765);

        System.out.println( "Search 98765; Index returned: " + position );
    }
}